﻿using Carmenta.Engine;
using CarmentaDemoWPF.ViewModels;
using CarmentaWpfClient.Utils;
using CarmentaWpfClient.ViewModels;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.IO;
using System.Reflection;
using System.Windows;

namespace CarmentaWpfClient
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        public App()
        {
            Runtime.Initialize();
            Services = ConfigureServices();
        }

        public new static App Current => (App)Application.Current;

        public IServiceProvider Services { get; }

        private static IServiceProvider ConfigureServices()
        {
            var services = new ServiceCollection();

            services.AddSingleton<MapProvider>(x =>
            {
                var pxFileDirectoryPath = Path.GetDirectoryName(
                    Assembly.GetExecutingAssembly().Location);
                return new MapProvider(pxFileDirectoryPath);
            });

            services.AddTransient<MapViewModel>();
            services.AddTransient<MainViewModel>();
            services.AddTransient<DrawerMenuViewModel>();
            services.AddTransient<LayerControlViewModel>();

            return services.BuildServiceProvider();
        }
    }
}
