﻿using CarmentaWpfClient.Models;

using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace CarmentaWpfClient.Utils
{
    public class MapProvider
    {
        private readonly Dictionary<string, MapModel> _mapLookup;

        public MapProvider(string directory)
        {
            var pxFiles = Directory.GetFiles(directory, "*.px");

            _mapLookup = pxFiles
                .Select(x => new MapModel(x))
                .ToDictionary(x => x.Name);
        }

        public IEnumerable<MapModel> Maps => _mapLookup.Values;

        public bool TryGetMap(string mapName, out MapModel mapModel)
            => _mapLookup.TryGetValue(mapName, out mapModel);
    }
}
