﻿using Carmenta.Engine;

using CarmentaWpfClient.Messages;
using CarmentaWpfClient.Models;
using CarmentaWpfClient.Utils;

using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Messaging;

using System.Linq;

namespace CarmentaDemoWPF.ViewModels
{
    public partial class MapViewModel : ObservableObject, IRecipient<UpdateViewMessage>
    {
        private readonly MapProvider _mapProvider;

        [ObservableProperty]
        private MapModel _currentMap;

        public MapViewModel(MapProvider mapProvider)
        {
            WeakReferenceMessenger.Default.Register(this);
            _mapProvider = mapProvider;

            CurrentMap = _mapProvider.Maps.First();
        }

        public Tool? Tool { get; private set; } = new StandardTool();

        public void Receive(UpdateViewMessage message) => CurrentMap.Update();
    }
}
